package com.ddabadi.stock.model;

import com.ddabadi.stock.model.base.Base;
import com.ddabadi.stock.model.enumerate.TransStatus;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.ToString;
import org.hibernate.annotations.Formula;

import javax.persistence.*;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Entity
@Data
@NoArgsConstructor
@EqualsAndHashCode
@ToString
@Table(name="payment_hd", schema = "public")
public class PaymentHd extends Base implements Serializable {

    @Id
    @SequenceGenerator(name = "pk_payment_hd_seq", sequenceName = "payment_hd_seq", allocationSize=1)
    @GeneratedValue( strategy = GenerationType.SEQUENCE, generator="pk_payment_hd_seq")
    private String id;

    // Generated by System
    // PYyyMM9999
    // PY -> system parameter
    @Column(length = 10)
    private String paymentNumber;

    @ManyToOne
    @JoinColumn(name = "payment_supplier")
    private Supplier supplier;

    @Temporal(TemporalType.DATE)
    @Column
    private Date transactionDate;

    @Column(length = 250)
    private String description;

    @Column
    private TransStatus status;

    // CASH, TRANSFER/ GIRO
    @Formula("select l.name from lookup l where l.code = payment_type ")
    private String paymentTypeDesc;

    @Column
    private String paymentType;

    // NO TRANSFER / GIRO
    private String paymentReffNumber;

    // GIRO Jatuh Tempo
    @Column
    @Temporal(TemporalType.DATE)
    private Date paymentDueDate;

    @Column
    private BigDecimal total;

}
